
	.586
	.model flat,stdcall
	option casemap:none
	
	include windows.inc
	include kernel32.inc
	include user32.inc
	include gdi32.inc
	include macros.asm
	
	includelib kernel32.lib
	includelib user32.lib
	includelib gdi32.lib
	
		WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
	
	
	
	.data
  _title db 'TurboAsmDx Diagnostics Window',0
  _class db 'FASMWIN32',0
  debugtxt  db 128 dup(0)

  align 4

  mainhwnd   dd 0
  hinstance  dd 0
  hdc	     dd 0
  mempointer dd 0
  memsize    dd 0
  fmax	     dq 1.101202393934
  handle     dd 0
  fonthandle dd 0
  hInstance dd 0
  
  
  .code
 WinMain PROC hInst:DWORD,hPrev:DWORD,lpCmd:DWORD,nShow:DWORD
 
	LOCAL msg  :MSG
	LOCAL wc   :WNDCLASSEX

		
			invoke GetModuleHandle,NULL
			mov hInstance,eax
			
			mov wc.cbClsExtra,0
			mov wc.cbSize,sizeof wc
			mov wc.cbWndExtra,0
			mov wc.hbrBackground,COLOR_WINDOW+1
			invoke LoadCursor,0,IDC_ARROW
			mov wc.hCursor,eax
			invoke LoadIcon,hInst,IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,eax
			push hInst
			pop wc.hInstance
			mov wc.lpfnWndProc,offset WndProc
			mov wc.lpszClassName,offset _class
			mov wc.lpszMenuName,NULL
			mov wc.style,0
		
			invoke  RegisterClassEx,addr wc
		
		
		invoke  CreateWindowEx, NULL,addr _class,addr _title, WS_OVERLAPPEDWINDOW,
					100, 30, 640, 480, NULL, NULL,hinstance, NULL
		mov   mainhwnd,eax
	
		invoke ShowWindow,mainhwnd,SW_SHOWNORMAL
			invoke UpdateWindow,mainhwnd
			.while TRUE 
				invoke GetMessage,ADDR msg,0,0,0
				.break .if(!eax)
				invoke TranslateMessage,ADDR msg
				invoke DispatchMessage,ADDR msg
			.endw
		mov eax,msg.wParam
	ret
WinMain ENDP


WndProc PROC hwnd:DWORD,wmsg:DWORD,wparam:DWORD,lparam:DWORD

		LOCAL rect :RECT
		LOCAL ps   :PAINTSTRUCT

		.if wmsg == WM_CREATE
			invoke CreateScalableFontResource, 0, CTXT("Cactus Love.fot"), CTXT("Cactus Love.ttf"), NULL
			invoke AddFontResource, CTXT("Cactus Love.fot")
			invoke CreateFont, 48, 24, 0, 0, FW_DONTCARE, 0, 0, 0, ANSI_CHARSET,\
				OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY,\
				0, CTXT("Cactus Love")
			mov    fonthandle, eax
			invoke  SendMessage, HWND_BROADCAST, WM_FONTCHANGE, 0, 0
			xor eax,eax
			ret
			
		.elseif wmsg == WM_PAINT
			invoke  BeginPaint,hwnd,addr ps ;returns a handle to the device context.
			mov     hdc, eax ;store the handle to the device context.
			invoke  GetClientRect, mainhwnd, addr rect
			invoke  SelectObject,hdc,fonthandle
			invoke  DrawText,hdc,CTXT("Cactus Love"), -1,addr rect, DT_WORDBREAK
			invoke  EndPaint,hwnd,addr  ps ;automatically free's handle to device context.
			xor eax,eax
			ret
			
		.elseif wmsg == WM_DESTROY
			invoke  DeleteObject,fonthandle
			invoke  RemoveFontResource,CTXT("Cactus Love.fot")
			invoke  SendMessage, HWND_BROADCAST, WM_FONTCHANGE, 0, 0
			invoke  DeleteFile,CTXT("Cactus Love.fot")
			invoke  PostQuitMessage, NULL
			xor eax,eax
			ret
			
		.endif	
			
			
	invoke  DefWindowProc, hwnd, wmsg, wparam, lparam
	ret
WndProc ENDP
	
	
END WinMain
	
	
	
 